Index: trunk/source/Lib/TAppCommon/TAppComCamPara.cpp
===================================================================
--- trunk/source/Lib/TAppCommon/TAppComCamPara.cpp	(revision 1085)
+++ trunk/source/Lib/TAppCommon/TAppComCamPara.cpp	(revision 1124)
@@ -1203,6 +1203,8 @@
   m_uiCamParsCodedPrecision = uiCodedCamParsPrecision;
   m_iLog2Precision          = iLog2Precision;
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if HHI_INTERVIEW_SKIP
   m_iCurrentFrameId         = 0 ;
+#endif
 #endif
 
Index: trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1085)
+++ trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1124)
@@ -154,7 +154,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   m_pucDisparityDerivedDepth = NULL;
   m_pbUseDDD = NULL;
+#endif
 #endif
 }
@@ -298,9 +300,11 @@
   // create pattern memory
   m_pcPattern            = (TComPattern*)xMalloc(TComPattern, 1);
-  
+
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   m_pucDisparityDerivedDepth         = (UChar*  )xMalloc( UChar,  uiNumPartition);
   m_pbUseDDD                         = (Bool*  ) xMalloc( Bool,   uiNumPartition);
 #endif 
+#endif
 
   // create motion vector fields
@@ -386,7 +390,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
     if ( m_pucDisparityDerivedDepth ) { xFree(m_pucDisparityDerivedDepth);          m_pucDisparityDerivedDepth        = NULL; }
     if ( m_pbUseDDD                 ) { xFree(m_pbUseDDD);                          m_pbUseDDD                        = NULL; }
+#endif
 #endif
 
@@ -518,9 +524,10 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
     m_pucDisparityDerivedDepth[ui] = pcFrom->m_pucDisparityDerivedDepth[ui];
     m_pbUseDDD[ui] = pcFrom->m_pbUseDDD[ui];
 #endif
-
+#endif
     m_puhWidth  [ui] = pcFrom->getWidth(ui);
     m_puhHeight [ui] = pcFrom->getHeight(ui);
@@ -604,7 +611,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
     memset( m_pucDisparityDerivedDepth        + firstElement, 0,           numElements * sizeof( *m_pucDisparityDerivedDepth ) );
     memset( m_pbUseDDD                        + firstElement, 0,           numElements * sizeof( *m_pbUseDDD ) );
+#endif
 #endif
 
@@ -784,7 +793,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
       m_pucDisparityDerivedDepth[ui] = 0;
       m_pbUseDDD[ui] = 0;
+#endif
 #endif
 
@@ -893,7 +904,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   memset( m_pucDisparityDerivedDepth,         0, iSizeInUchar );
   memset( m_pbUseDDD,                         0, iSizeInBool );
+#endif
 #endif
 
@@ -990,7 +1003,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
       m_pucDisparityDerivedDepth[ui] = pcCU->m_pucDisparityDerivedDepth[uiPartOffset+ui];
       m_pbUseDDD[ui]                 = pcCU->m_pbUseDDD[uiPartOffset+ui];
+#endif
 #endif
 
@@ -1139,7 +1154,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   m_pucDisparityDerivedDepth          = pcCU->getDDDepth()        + uiPart;
   m_pbUseDDD                          = pcCU->getUseDDD()         + uiPart;
+#endif
 #endif
 
@@ -1292,7 +1309,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   m_pucDisparityDerivedDepth         = pcCU->getDDDepth()              + uiAbsPartIdx;
   m_pbUseDDD                         = pcCU->getUseDDD()              + uiAbsPartIdx;
+#endif
 #endif
     
@@ -1360,8 +1379,10 @@
   memcpy( m_puhCbf[1] + uiOffset, pcCU->getCbf(TEXT_CHROMA_U), iSizeInUchar );
   memcpy( m_puhCbf[2] + uiOffset, pcCU->getCbf(TEXT_CHROMA_V), iSizeInUchar );
-  
+
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   memcpy( m_pucDisparityDerivedDepth          + uiOffset, pcCU->getDDDepth(),         iSizeInUchar );
   memcpy( m_pbUseDDD                          + uiOffset, pcCU->getUseDDD(),          iSizeInBool );
+#endif
 #endif
 
@@ -1464,7 +1485,9 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   memcpy( rpcCU->getDDDepth()          + m_uiAbsIdxInLCU, m_pucDisparityDerivedDepth,         iSizeInUchar  );
   memcpy( rpcCU->getUseDDD()           + m_uiAbsIdxInLCU, m_pbUseDDD,                         iSizeInBool  );
+#endif
 #endif
 
@@ -1600,8 +1623,10 @@
   memcpy( rpcCU->getCbf(TEXT_CHROMA_U) + uiPartOffset, m_puhCbf[1], iSizeInUchar );
   memcpy( rpcCU->getCbf(TEXT_CHROMA_V) + uiPartOffset, m_puhCbf[2], iSizeInUchar );
-  
+
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   memcpy( rpcCU->getDDDepth()          + uiPartOffset, m_pucDisparityDerivedDepth,         iSizeInUchar );
   memcpy( rpcCU->getUseDDD()           + uiPartOffset, m_pbUseDDD,                         iSizeInBool );
+#endif
 #endif
 
@@ -1671,4 +1696,5 @@
 }
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
 Void TComDataCU::setDDDepthSubParts ( UChar ucDDD, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
@@ -1687,4 +1713,5 @@
 }
 
+#endif
 #endif
 
@@ -2398,5 +2425,9 @@
     Bool depthRefineFlag = false;
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    depthRefineFlag = m_pcSlice->getDepthRefinementFlag(  );
+#else
     depthRefineFlag = m_pcSlice->getVPS()->getDepthRefinementFlag( m_pcSlice->getLayerIdInVps() );
+#endif
 #endif // H_3D_NBDV_REF
     
@@ -3309,5 +3340,9 @@
 inline Bool TComDataCU::xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount)
 {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if ( m_pcSlice->getViewIndex() == 0 || !m_pcSlice->getViewSynthesisPredFlag( ) || m_pcSlice->getIsDepth() || pDInfo->m_aVIdxCan == -1)
+#else
   if ( m_pcSlice->getViewIndex() == 0 || !m_pcSlice->getVPS()->getViewSynthesisPredFlag( m_pcSlice->getLayerIdInVps() ) || m_pcSlice->getIsDepth() || pDInfo->m_aVIdxCan == -1)
+#endif
   {
     return false;
@@ -3864,5 +3899,7 @@
 )
 {
+#if !SEC_A1_BASED_VSP_J0039
   UInt uiAbsPartAddr = m_uiAbsIdxInLCU + uiAbsPartIdx;
+#endif
 #if H_3D_IV_MERGE
   ////////////////////////////
@@ -3877,6 +3914,8 @@
   UChar tmpDir;
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   m_iUseDDDCandIdx = -1;
+#endif
 #endif
 
@@ -3919,5 +3958,9 @@
   deriveLeftBottomIdxGeneral  ( uiAbsPartIdx, uiPUIdx, uiPartIdxLB );
 #if H_3D
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool bMPIFlag   = getSlice()->getMpiFlag(); 
+#else
   Bool bMPIFlag   = getSlice()->getVPS()->getMPIFlag( getSlice()->getLayerIdInVps() );
+#endif
   Bool bIsDepth = getSlice()->getIsDepth();
 #endif 
@@ -3979,7 +4022,9 @@
 
   // above
+#if !SEC_A1_BASED_VSP_J0039
   UInt uiAbovePartIdx = 0;
   TComDataCU* pcCUAbove = 0;
   pcCUAbove = getPUAbove( uiAbovePartIdx, uiPartIdxRT );
+#endif
 
   if (getAvailableFlagB1())
@@ -3988,4 +4033,7 @@
 #if H_3D_VSP
     ,
+#if SEC_A1_BASED_VSP_J0039
+      false
+#else
       ( ( ( getAddr() - pcCUAbove->getAddr() ) == 0) && (pcCUAbove->getVSPFlag(uiAbovePartIdx) != 0) 
 #if H_3D_IC
@@ -4000,4 +4048,5 @@
       )
 #endif
+#endif
       , false
       ); 
@@ -4006,7 +4055,9 @@
 
   // above right
+#if !SEC_A1_BASED_VSP_J0039
   UInt uiAboveRightPartIdx = 0;
   TComDataCU* pcCUAboveRight = 0;
   pcCUAboveRight = getPUAboveRight( uiAboveRightPartIdx, uiPartIdxRT );
+#endif
 
   if (getAvailableFlagB0())
@@ -4015,4 +4066,7 @@
 #if H_3D_VSP
     ,
+#if SEC_A1_BASED_VSP_J0039
+      false
+#else
       ( ( ( getAddr() - pcCUAboveRight->getAddr() ) == 0) && (pcCUAboveRight->getVSPFlag(uiAboveRightPartIdx) != 0) 
 #if H_3D_IC
@@ -4027,4 +4081,5 @@
       )
 #endif
+#endif
       , false
       ); 
@@ -4033,6 +4088,8 @@
 
   // left bottom
+#if !SEC_A1_BASED_VSP_J0039
   UInt uiLeftBottomPartIdx = 0;
   TComDataCU* pcCULeftBottom = getPUBelowLeft( uiLeftBottomPartIdx, uiPartIdxLB );
+#endif
 
   if (getAvailableFlagA0())
@@ -4041,4 +4098,7 @@
 #if H_3D_VSP
     ,
+#if SEC_A1_BASED_VSP_J0039
+      false
+#else
       (pcCULeftBottom->getVSPFlag(uiLeftBottomPartIdx) != 0
 #if H_3D_IC
@@ -4053,4 +4113,5 @@
       )
 #endif
+#endif
       , false
       ); 
@@ -4059,7 +4120,9 @@
 
   // above left
+#if !SEC_A1_BASED_VSP_J0039
   UInt uiAboveLeftPartIdx = 0;
   TComDataCU* pcCUAboveLeft = 0;
   pcCUAboveLeft = getPUAboveLeft( uiAboveLeftPartIdx, uiAbsPartAddr );
+#endif
 
   if (getAvailableFlagB2())
@@ -4068,4 +4131,7 @@
 #if H_3D_VSP
     ,
+#if SEC_A1_BASED_VSP_J0039
+      false
+#else
       ( ( ( getAddr() - pcCUAboveLeft->getAddr() ) == 0) && (pcCUAboveLeft->getVSPFlag(uiAboveLeftPartIdx) != 0) 
 #if H_3D_IC
@@ -4079,4 +4145,5 @@
 #endif
       )
+#endif
 #endif
       , false
@@ -4276,4 +4343,5 @@
     }
   }
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   if( m_pcSlice->getIsDepth() && m_pcSlice->getViewIndex() != 0  && bMPIFlag )
@@ -4360,4 +4428,5 @@
   }
 #endif
+#endif
   /////////////////////////////////////////////////////////////////
   //////// DERIVE IvMC, IvMCShift,IvDCShift, IvDC  Candidates /////
@@ -4372,5 +4441,9 @@
   Int    ivCandDir   [4] = {0, 0, 0, 0};
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool ivMvPredFlag   = getSlice()->getIvMvPredFlag();
+#else
   Bool ivMvPredFlag   = getSlice()->getVPS()->getIvMvPredFlag( getSlice()->getLayerIdInVps() );
+#endif
 
   ivMvPredFlag &= (nPSW + nPSH > 12);
@@ -4455,5 +4528,9 @@
 
 #if H_3D
+#if SEC_A1_BASED_VSP_J0039
+  iCount += m_mergCands[MRG_A1].m_bAvailable + m_mergCands[MRG_B1].m_bAvailable;
+#else
   iCount += m_mergCands[MRG_A1].m_bAvailable + m_mergCands[MRG_B1].m_bAvailable + m_mergCands[MRG_B0].m_bAvailable;
+#endif
 #else
   //left
@@ -4554,4 +4631,5 @@
 #endif
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   // early termination
@@ -4561,4 +4639,47 @@
   }
 #endif
+#endif
+
+#if SEC_A1_BASED_VSP_J0039
+#if H_3D_VSP
+  /////////////////////////////////////////////////
+  //////// VIEW SYNTHESIS PREDICTION (VSP) ////////
+  /////////////////////////////////////////////////
+  if (iCount<getSlice()->getMaxNumMergeCand())
+  {
+    if (
+      (!getAvailableFlagA1() || !(pcCULeft->getVSPFlag(uiLeftPartIdx) != 0)) &&
+#if H_3D_IC
+      !bICFlag &&
+#endif
+#if H_3D_ARP
+      !bARPFlag &&
+#endif
+#if H_3D
+      (nPSW + nPSH > 12) &&
+#endif
+#if H_3D_DBBP
+      !bDBBPFlag &&
+#endif
+      xAddVspCand( mrgCandIdx, &cDisInfo, iCount ) )
+    {
+      return;
+    }
+
+    // early termination
+    if (iCount == getSlice()->getMaxNumMergeCand())
+    {
+      return;
+    }
+#endif
+#if H_3D_VSP
+  }
+#endif
+
+#if H_3D
+  iCount += m_mergCands[MRG_B0].m_bAvailable;
+#endif
+#endif
+
 
 #if H_3D_IV_MERGE 
@@ -4615,4 +4736,5 @@
 #endif // H_3D_IV_MERGE 
 
+#if !SEC_A1_BASED_VSP_J0039
 #if H_3D_VSP
   /////////////////////////////////////////////////
@@ -4648,4 +4770,5 @@
 #if H_3D
   }
+#endif
 #endif
 
@@ -5893,5 +6016,9 @@
     iScale = xGetDistScaleFactor( iCurrViewId, iCurrRefViewId, iColViewId, iColRefViewId );
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if ( iScale != 4096 && m_pcSlice->getIvMvScalingFlag( ) )
+#else
     if ( iScale != 4096 && m_pcSlice->getVPS()->getIvMvScalingFlag(getSlice()->getLayerIdInVps()) ) 
+#endif
     {
       rcMv = cColMv.scaleMv( iScale );
@@ -6076,4 +6203,24 @@
 
   TComMv cMv; 
+#if LGE_DEFAULT_DV_J0046
+  if ( getSlice()->getDefaultRefViewIdxAvailableFlag() )
+  {
+      Int iViewIdx = getSlice()->getDefaultRefViewIdx();
+      pDisp->m_aVIdxCan = iViewIdx;
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      Int iDisp     = getSlice()->getDepthToDisparityB( iViewIdx )[ (Int64) (1 << ( getSlice()->getSPS()->getBitDepthY() - 1 )) ];
+#else
+      Int iDisp     = getSlice()->getDepthToDisparityB( iViewIdx )[ 1 << ( getSlice()->getSPS()->getBitDepthY() - 1 ) ];
+#endif
+
+      cMv.setHor(iDisp);
+      cMv.setVer(0);
+      pDisp->m_acNBDV = cMv;
+      pDisp->m_aVIdxCan = iViewIdx;
+
+      return true;
+  }
+  return false;
+#else
 #if MTK_I0093
   Int iDisp     = getSlice()->getDepthToDisparityB( 0 )[ (Int64) (1 << ( getSlice()->getSPS()->getBitDepthY() - 1 )) ];
@@ -6087,4 +6234,5 @@
 
   return true;
+#endif
 }
 #endif
@@ -6118,4 +6266,5 @@
     }
     break;
+#if !SINGLE_DEPTH_SIMP_J0115
   case 2: // Above
     if(yP != 0)
@@ -6139,4 +6288,5 @@
     }
     break;
+#endif
   default:
       break;
@@ -6177,5 +6327,9 @@
   }
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( !m_pcSlice->getDepthRefinementFlag( ) )
+#else
   if( !m_pcSlice->getVPS()->getDepthRefinementFlag( m_pcSlice->getLayerIdInVps() ) )
+#endif
   {
     bDepthRefine = false;
@@ -6338,4 +6492,37 @@
   pDInfo->m_acNBDV = defaultDV;
 
+#if LGE_DEFAULT_DV_J0046
+  if (getSlice()->getDefaultRefViewIdxAvailableFlag())
+  {
+      pDInfo->m_aVIdxCan = getSlice()->getDefaultRefViewIdx();
+
+#if H_3D_NBDV_REF
+          TComPic* picDepth = NULL;
+#if H_3D_FCO_VSP_DONBDV_E0163
+          picDepth  = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
+      if ( picDepth->getPicYuvRec() != NULL )  
+      {
+          defaultDV.setZero();
+      }
+      else // Go back with virtual depth
+      {
+          picDepth = getSlice()->getIvPic( true, getSlice()->getDefaultRefViewIdx());
+      }
+
+      assert(picDepth != NULL);
+#else
+          picDepth = getSlice()->getIvPic( true, getSlice()->getDefaultRefViewIdx());
+#endif
+      if (picDepth && bDepthRefine)
+      {
+          estimateDVFromDM(getSlice()->getDefaultRefViewIdx(), uiPartIdx, picDepth, uiPartAddr, &defaultDV ); // from base view
+      }
+      pDInfo->m_acDoNBDV = defaultDV;
+#endif
+#if LGE_SIMP_DISP_AVAIL_J0041
+      return true;
+#endif
+  }
+#else
   Int valid = 0;
   Int viewIndex = 0;
@@ -6389,5 +6576,9 @@
     pDInfo->m_acDoNBDV = defaultDV;
 #endif
-  }
+#if LGE_SIMP_DISP_AVAIL_J0041
+    return true;
+#endif
+  }
+#endif
   return false; 
 }
@@ -6643,5 +6834,9 @@
   Bool depthRefineFlag = false; 
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  depthRefineFlag = m_pcSlice->getDepthRefinementFlag( ); 
+#else
   depthRefineFlag = m_pcSlice->getVPS()->getDepthRefinementFlag( m_pcSlice->getLayerIdInVps() ); 
+#endif
 #endif // H_3D_NBDV_REF
 
@@ -6701,4 +6896,7 @@
 Void TComDataCU::getSPPara(Int iPUWidth, Int iPUHeight, Int& iNumSP, Int& iNumSPInOneLine, Int& iSPWidth, Int& iSPHeight)
 {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Int iSubPUSize = ( getSlice()->getIsDepth() ? getSlice()->getMpiSubPbSize() : getSlice()->getSubPbSize() );
+#else
   Int iSubPUSize = 1<<getSlice()->getVPS()->getSubPULog2Size(getSlice()->getLayerId());
   if( getSlice()->getIsDepth() )
@@ -6706,9 +6904,17 @@
     iSubPUSize = 1<<getSlice()->getVPS()->getSubPUMPILog2Size(getSlice()->getLayerId());
   }
+#endif
 
   iNumSPInOneLine = iPUWidth/iSubPUSize;
+#if !HS_SP_SIMP_J0066
   iNumSPInOneLine = iNumSPInOneLine < 1 ? 1: iNumSPInOneLine;
+#endif
   Int iNumSPInOneColumn = iPUHeight/iSubPUSize;
+#if !HS_SP_SIMP_J0066
   iNumSPInOneColumn = iNumSPInOneColumn < 1 ? 1: iNumSPInOneColumn;
+#else
+  iNumSPInOneLine = (iPUHeight % iSubPUSize != 0 || iPUWidth % iSubPUSize != 0 ) ? 1 : iNumSPInOneLine;
+  iNumSPInOneColumn = (iPUHeight % iSubPUSize != 0  || iPUWidth % iSubPUSize != 0 ) ? 1 : iNumSPInOneColumn;
+#endif
   iNumSP = iNumSPInOneLine * iNumSPInOneColumn;
 
@@ -6784,5 +6990,9 @@
   Bool depthRefineFlag = false; 
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  depthRefineFlag = m_pcSlice->getDepthRefinementFlag( ); 
+#else
   depthRefineFlag = m_pcSlice->getVPS()->getDepthRefinementFlag( m_pcSlice->getLayerIdInVps() ); 
+#endif
 #endif // H_3D_NBDV_REF
 
Index: trunk/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 1085)
+++ trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 1124)
@@ -227,5 +227,5 @@
   DisInfo       m_cDefaultDisInfo;    ///< Default disparity information for initializing
 #endif
-
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   UChar*        m_pucDisparityDerivedDepth;
@@ -234,5 +234,5 @@
   UChar         m_ucDDTmpDepth;
 #endif
-
+#endif
 #if H_3D_IV_MERGE
   TComMotionCand  m_mergCands[MRG_IVSHIFT+1];
@@ -743,4 +743,5 @@
   UInt          getCoefScanIdx(UInt uiAbsPartIdx, UInt uiWidth, Bool bIsLuma, Bool bIsIntra);
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   UChar*       getDDDepth        ()                        { return m_pucDisparityDerivedDepth;        }
@@ -759,4 +760,5 @@
   Int          getUseDDDCandIdx(){ return m_iUseDDDCandIdx;}
 
+#endif
 #endif
 
Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1085)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1124)
@@ -1158,4 +1158,5 @@
   pcCU->clipMv(cMv);
 
+#if !LGE_DDD_REMOVAL_J0042_J0030
 #if H_3D_DDD
   if( pcCU->getUseDDD( uiPartAddr ) )
@@ -1193,4 +1194,5 @@
       //return;
   } else
+#endif
 #endif
 #if H_3D_ARP
@@ -1949,4 +1951,5 @@
     Int a, b, i, j;
     const Int iShift = IC_CONST_SHIFT;
+
     xGetLLSICPrediction( cu, mv, refPic, a, b, TEXT_CHROMA_U ); // Cb
     for ( i = 0; i < cxHeight; i++ )
@@ -2187,6 +2190,13 @@
       x += pRef[j];
       y += pRec[j];
-      xx += (pRef[j] * pRef[j])>>precShift;
-      xy += (pRef[j] * pRec[j])>>precShift;
+#if LGE_CHROMA_IC_J0050_J0034
+      if ( eType == TEXT_LUMA )
+      {
+#endif
+        xx += (pRef[j] * pRef[j])>>precShift;
+        xy += (pRef[j] * pRec[j])>>precShift;
+#if LGE_CHROMA_IC_J0050_J0034
+      }
+#endif
     }
     iCountShift += g_aucConvertToBit[ uiWidth ] + 1;
@@ -2217,8 +2227,13 @@
       x += pRef[0];
       y += pRec[0];
-
-      xx += (pRef[0] * pRef[0])>>precShift;
-      xy += (pRef[0] * pRec[0])>>precShift;
-
+#if LGE_CHROMA_IC_J0050_J0034
+      if ( eType == TEXT_LUMA )
+      {
+#endif
+        xx += (pRef[0] * pRef[0])>>precShift;
+        xy += (pRef[0] * pRec[0])>>precShift;
+#if LGE_CHROMA_IC_J0050_J0034
+      }
+#endif      
       pRef += iRefStride*2;
       pRec += iRecStride*2;
@@ -2234,4 +2249,13 @@
   }
 
+#if LGE_CHROMA_IC_J0050_J0034
+  if (  eType != TEXT_LUMA )
+  {
+    a = 32;
+    b = (  y - x + ( 1 << ( iCountShift - 1 ) ) ) >> iCountShift;
+  }
+  else
+  {
+#endif
   xy += xx >> IC_REG_COST_SHIFT;
   xx += xx >> IC_REG_COST_SHIFT;
@@ -2275,4 +2299,7 @@
     }
   }   
+#if LGE_CHROMA_IC_J0050_J0034
+  }
+#endif
 }
 #endif
Index: trunk/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1085)
+++ trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1124)
@@ -362,5 +362,9 @@
 const UChar g_dmm1TabIdxBits[6] =
 { //2x2   4x4   8x8 16x16 32x32 64x64
+#if MTK_DMM_SIM_J0035 
+     0,    7,   10,   9,    9,   13 };
+#else
      0,    7,   10,   11,   11,   13 };
+#endif
 
 const UChar g_dmm3IntraTabIdxBits[6] =
@@ -763,4 +767,14 @@
     }
 
+#if MTK_DMM_SIM_J0035
+    for( Int iK = 0; iK < uiBlockSize; iK += (uiWidth>=16 ?2:1))
+    {
+      for( Int iL = 0; iL < uiBlockSize; iL += ((uiWidth>=16 && uiOri<4)?2:1) )
+      {
+        cTempWedgelet.setWedgelet( uhStartX + (iK*iStepStartX) , uhStartY + (iK*iStepStartY), uhEndX + (iL*iStepEndX), uhEndY + (iL*iStepEndY), (UChar)uiOri, eWedgeRes, ((iL%2)==0 && (iK%2)==0) );
+        addWedgeletToList( cTempWedgelet, racWedgeList, racWedgeRefList );
+      }
+    }
+#else
     for( Int iK = 0; iK < uiBlockSize; iK++ )
     {
@@ -771,4 +785,5 @@
       }
     }
+#endif
   }
 
